package menubar
{
	import com.vulcan.application.framework.NameUtils;
	import com.vulcan.application.framework.behavior.SubSystem;
	import com.vulcan.mvc.patterns.mediator.Mediator;
	
	import flash.utils.getQualifiedClassName;
	
	import mx.controls.MenuBar;
	import mx.events.MenuEvent;

	/**  
	 * 
	 * @Project : Vulcan Project
	 * @Author : Park Dong-il (pdi1066@naver.com)
	 * @Date : 2010. 5. 27.
	 */
	
	public class MenuToolBarMED extends Mediator
	{
		public function MenuToolBarMED(mediatorName:String=null, viewComponent:Object=null)
		{
			super(mediatorName, viewComponent);
		}
		
		public static const NAME:String = getQualifiedClassName(MenuToolBarMED);
		public static const NAME_TYPE:String = NameUtils.TYPE_APPLICATION;
		
		
		public function get instance():MenuBar
		{
			return viewComponent as MenuBar
		}
		
		/////////////////////////////////
		// Event Binding
		/////////////////////////////////
		
		/** @inheritDoc */
		override public function onRegister():void
		{
			instance.addEventListener(MenuEvent.ITEM_CLICK, onItemClick);
			
			var menuPX:MenuToolBarDATA = SubSystem(facade).getProxy(MenuToolBarDATA) as MenuToolBarDATA;
			var menu:XML = menuPX.getData() as XML;
			
			instance.dataProvider = menu.children();
		}
		
		// Mediator가 삭제될때
		override public function onRemove( ):void
		{
			instance.removeEventListener(MenuEvent.ITEM_CLICK, onItemClick);
			instance.dataProvider = null;
		}
		
		protected function onItemClick(event:MenuEvent):void
		{
			var commendConst:String = event.item.@data;
			if(!commendConst) return;
			trace("commendString - ", commendConst);
		}

		////////////////////////////////////
		// End
		////////////////////////////////////
	}
}