/*
* 
* 	Copyright (C) 2010 Dong-il Park.(pdi1066@naver.com)
* 	This file is part of Vulcan Project.
* 
* 	This program is free software; you can redistribute it and/or modify it under 
* 	the terms of the GNU General Public License as published by the Free Software Foundation; 
* 	either version 2 of the License, or (at your option) any later version.
* 
* 	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
* 	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
* 	See the GNU General Public License for more details.
* 
* 	You should have received a copy of the GNU General Public License along with this program; 
* 	if not, see <http://www.gnu.org/licenses/>.
* 
* */

package newsystem
{
	import com.vulcan.application.framework.NameUtils;
	import com.vulcan.application.framework.behavior.SubSystem;
	import com.vulcan.application.framework.behavior.builder.SubSystemBuilder;
	import com.vulcan.application.framework.behavior.group.InstanceGroup;
	import com.vulcan.application.framework.behavior.group.ManagerGroup;
	
	import flash.utils.getQualifiedClassName;
	
	import mx.core.UIComponent;
	
	public class NewSubSystem extends SubSystem
	{
		public function NewSubSystem(key:String)
		{
			super(key);
		}
		
		/////////////////////////////////
		// Static - 파생 클래스 필수 구현
		/////////////////////////////////
		
		static public const NAME:String = getQualifiedClassName(NewSubSystem);
		static public const NAME_TYPE:String = NameUtils.TYPE_APPLICATION;
		
		static protected function getInstance(key:String):SubSystem
		{
			if ( instanceMap[ key ] == null ){
				instanceMap[ key ] = new NewSubSystem(key);
			}
			return instanceMap[ key ] as NewSubSystem;
		}
		
		static public function start(multitonKey:String, startMain:UIComponent):SubSystem
		{
			var system:SubSystem = NewSubSystem.getInstance(multitonKey);
			system.setup(startMain);
			
			return system;
		}
		
		
		/////////////////////////////////
		// SubSystem의 MVC 구조 빌드
		/////////////////////////////////
		
		// 하위 클래스에서 인스턴스를 결정한다.
		override protected function createBuilder():SubSystemBuilder
		{
			var builder:SubSystemBuilder = new NewSubSystemBuilder();
			return builder;
		}
		
		//-------------------------------
		// Application에서 Instance 참조 목록 생성
		//-------------------------------
		
		// 하위 클래스에서 인스턴스를 결정한다.
		override protected function createInstance():InstanceGroup
		{
			var instance:InstanceGroup = new NewInstanceGroup();
			return instance;
		}
		
		////////////////////////////////
		// End
		////////////////////////////////
	}
}