/*
* 
* 	Copyright (C) 2010 Dong-il Park.(pdi1066@naver.com)
* 	This file is part of Vulcan Project.
* 
* 	This program is free software; you can redistribute it and/or modify it under 
* 	the terms of the GNU General Public License as published by the Free Software Foundation; 
* 	either version 2 of the License, or (at your option) any later version.
* 
* 	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
* 	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
* 	See the GNU General Public License for more details.
* 
* 	You should have received a copy of the GNU General Public License along with this program; 
* 	if not, see <http://www.gnu.org/licenses/>.
* 
* */

package newsystem
{
	import com.vulcan.application.framework.behavior.builder.SubSystemBuilder;
	import com.vulcan.application.framework.model.data.ConfigDATA;
	
	import menubar.MenuToolBarDATA;
	import menubar.MenuToolBarMED;
	
	import mx.core.UIComponent;
	
	public class NewSubSystemBuilder extends SubSystemBuilder
	{
		public function NewSubSystemBuilder()
		{
			super();
		}
		
		/////////////////////////////////
		// configuration
		/////////////////////////////////
		
		override protected function registConfigDataList():void
		{
			//registerDATA( ConfigDATA, "./assets/config.xml" );
		}
		
		//-------------------------------
		// Data Proxy 등록 - app 구동에 필요한 데이터를 로드
		//-------------------------------
		
		// 등록되는 Proxy Class 는 XmlLoaderBase의 하위 클래스여야 합니다.
		override protected function registDataList():void
		{
			//super.registDataList();
			
			//registerDATA( WindowItemDATA, "./assets/windowItem.xml" );
			//registerDATA( DocumentDATA, "./assets/documentType.xml" );
			
			registerDATA( MenuToolBarDATA, "./assets/menuToolBar.xml" );
		}
		
		// Mediator 등록
		override protected function registMediatorList():void
		{
			super.registMediatorList();
			
			var menuToolBar:UIComponent = facade.instance.find("menuToolBar");
			if(menuToolBar){
				registerMED(MenuToolBarMED, menuToolBar);
			}
		}
		
		////////////////////////////////
		// End
		////////////////////////////////
	}
}